# HG changeset patch
# Node ID ed1cd011456b
# Parent  b20e79e7d6f5
diff --git a/ChangeLog.API b/ChangeLog.API
--- a/ChangeLog.API
+++ b/ChangeLog.API
@@ -238,6 +238,8 @@ version 3.0.0 (??/??/????):
 		* PurpleRequestFieldGroup is now a GObject, and renamed to
 		  PurpleRequestGroup. Please see the documentation for
 		  details.
+		* PurpleRequestFields is now a GObject, and renamed to
+		  PurpleRequestPage. Please see the documentation for details.
 		* purple_request_field_get_field_type_hint renamed to
 		  purple_request_field_get_type_hint
 		* purple_request_field_group_get_tab
@@ -720,6 +722,7 @@ version 3.0.0 (??/??/????):
 		* purple_request_field_set_ui_data
 		* purple_request_field_group_destroy. Use g_object_unref
 		  instead.
+		* purple_request_fields_destroy. Use g_object_unref instead.
 		* purple_request_fields_get_autosensitive
 		* PurpleRoomlistRoomType
 		* purple_roomlist_expand_category
diff --git a/finch/gntblist.c b/finch/gntblist.c
--- a/finch/gntblist.c
+++ b/finch/gntblist.c
@@ -530,13 +530,12 @@ remove_new_empty_group(G_GNUC_UNUSED gpo
 }
 
 static void
-add_buddy_cb(G_GNUC_UNUSED gpointer data, PurpleRequestFields *allfields)
-{
-	const char *username = purple_request_fields_get_string(allfields, "screenname");
-	const char *alias = purple_request_fields_get_string(allfields, "alias");
-	const char *group = purple_request_fields_get_string(allfields, "group");
-	const char *invite = purple_request_fields_get_string(allfields, "invite");
-	PurpleAccount *account = purple_request_fields_get_account(allfields, "account");
+add_buddy_cb(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
+	const char *username = purple_request_page_get_string(page, "screenname");
+	const char *alias = purple_request_page_get_string(page, "alias");
+	const char *group = purple_request_page_get_string(page, "group");
+	const char *invite = purple_request_page_get_string(page, "invite");
+	PurpleAccount *account = purple_request_page_get_account(page, "account");
 	const char *error = NULL;
 	PurpleGroup *grp;
 	PurpleBuddy *buddy;
@@ -582,11 +581,11 @@ finch_request_add_buddy(G_GNUC_UNUSED Pu
                         PurpleAccount *account, const char *username,
                         const char *grp, const char *alias)
 {
-	PurpleRequestFields *fields = purple_request_fields_new();
+	PurpleRequestPage *page = purple_request_page_new();
 	PurpleRequestGroup *group = purple_request_group_new(NULL);
 	PurpleRequestField *field;
 
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("screenname", _("Username"), username, FALSE);
 	purple_request_group_add_field(group, field);
@@ -608,7 +607,7 @@ finch_request_add_buddy(G_GNUC_UNUSED Pu
 	purple_request_group_add_field(group, field);
 
 	purple_request_fields(NULL, _("Add Buddy"), NULL, _("Please enter buddy information."),
-			fields,
+			page,
 			_("Add"), G_CALLBACK(add_buddy_cb),
 			_("Cancel"), NULL,
 			purple_request_cpar_from_account(account),
@@ -636,8 +635,7 @@ join_chat(PurpleChat *chat)
 }
 
 static void
-add_chat_cb(G_GNUC_UNUSED gpointer data, PurpleRequestFields *allfields)
-{
+add_chat_cb(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
 	PurpleAccount *account;
 	const char *alias, *name, *group;
 	PurpleChat *chat;
@@ -647,11 +645,11 @@ add_chat_cb(G_GNUC_UNUSED gpointer data,
 	gboolean autojoin;
 	PurpleProtocol *protocol;
 
-	account = purple_request_fields_get_account(allfields, "account");
-	name = purple_request_fields_get_string(allfields, "name");
-	alias = purple_request_fields_get_string(allfields, "alias");
-	group = purple_request_fields_get_string(allfields, "group");
-	autojoin = purple_request_fields_get_bool(allfields, "autojoin");
+	account = purple_request_page_get_account(page, "account");
+	name = purple_request_page_get_string(page, "name");
+	alias = purple_request_page_get_string(page, "alias");
+	group = purple_request_page_get_string(page, "group");
+	autojoin = purple_request_page_get_bool(page, "autojoin");
 
 	if (!purple_account_is_connected(account) || !name || !*name)
 		return;
@@ -684,11 +682,11 @@ finch_request_add_chat(G_GNUC_UNUSED Pur
                        PurpleAccount *account, PurpleGroup *grp,
                        const char *alias, const char *name)
 {
-	PurpleRequestFields *fields = purple_request_fields_new();
+	PurpleRequestPage *page = purple_request_page_new();
 	PurpleRequestGroup *group = purple_request_group_new(NULL);
 	PurpleRequestField *field;
 
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_account_new("account", _("Account"), NULL);
 	purple_request_field_account_set_show_all(field, FALSE);
@@ -711,7 +709,7 @@ finch_request_add_chat(G_GNUC_UNUSED Pur
 
 	purple_request_fields(NULL, _("Add Chat"), NULL,
 			_("You can edit more information from the context menu later."),
-			fields, _("Add"), G_CALLBACK(add_chat_cb), _("Cancel"), NULL,
+			page, _("Add"), G_CALLBACK(add_chat_cb), _("Cancel"), NULL,
 			NULL, NULL);
 }
 
@@ -980,11 +978,13 @@ add_custom_action(GntMenu *menu, const c
 }
 
 static void
-chat_components_edit_ok(PurpleChat *chat, PurpleRequestFields *allfields)
+chat_components_edit_ok(PurpleChat *chat, PurpleRequestPage *page)
 {
 	GList *groups, *fields;
 
-	for (groups = purple_request_fields_get_groups(allfields); groups; groups = groups->next) {
+	for(groups = purple_request_page_get_groups(page); groups;
+	    groups = groups->next)
+	{
 		fields = purple_request_group_get_fields(groups->data);
 		for (; fields; fields = fields->next) {
 			PurpleRequestField *field = fields->data;
@@ -1009,7 +1009,7 @@ chat_components_edit_ok(PurpleChat *chat
 static void
 chat_components_edit(G_GNUC_UNUSED PurpleBlistNode *selected, PurpleChat *chat)
 {
-	PurpleRequestFields *fields = purple_request_fields_new();
+	PurpleRequestPage *page = purple_request_page_new();
 	PurpleRequestGroup *group = purple_request_group_new(NULL);
 	PurpleRequestField *field;
 	GList *parts, *iter;
@@ -1017,7 +1017,7 @@ chat_components_edit(G_GNUC_UNUSED Purpl
 	PurpleProtocolChatEntry *pce;
 	PurpleConnection *gc;
 
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	gc = purple_account_get_connection(purple_chat_get_account(chat));
 	protocol = purple_connection_get_protocol(gc);
@@ -1048,7 +1048,7 @@ chat_components_edit(G_GNUC_UNUSED Purpl
 	g_list_free(parts);
 
 	purple_request_fields(NULL, _("Edit Chat"), NULL, _("Please Update the necessary fields."),
-			fields, _("Edit"), G_CALLBACK(chat_components_edit_ok), _("Cancel"), NULL,
+			page, _("Edit"), G_CALLBACK(chat_components_edit_ok), _("Cancel"), NULL,
 			NULL, chat);
 }
 
@@ -2518,14 +2518,13 @@ static void sort_blist_change_cb(G_GNUC_
 
 /* send_im_select* -- Xerox */
 static void
-send_im_select_cb(G_GNUC_UNUSED gpointer data, PurpleRequestFields *fields)
-{
+send_im_select_cb(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
 	PurpleAccount *account;
 	const char *username;
 	PurpleConversation *im;
 
-	account  = purple_request_fields_get_account(fields, "account");
-	username = purple_request_fields_get_string(fields,  "screenname");
+	account = purple_request_page_get_account(page, "account");
+	username = purple_request_page_get_string(page, "screenname");
 
 	im = purple_im_conversation_new(account, username);
 	purple_conversation_present(im);
@@ -2534,14 +2533,14 @@ send_im_select_cb(G_GNUC_UNUSED gpointer
 static void
 send_im_select(G_GNUC_UNUSED GntMenuItem *item, G_GNUC_UNUSED gpointer n)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("screenname", _("Name"), NULL, FALSE);
 	purple_request_field_set_type_hint(field, "screenname");
@@ -2560,13 +2559,12 @@ send_im_select(G_GNUC_UNUSED GntMenuItem
 	        purple_blist_get_default(), _("New Instant Message"), NULL,
 	        _("Please enter the username or alias of the person "
 	          "you would like to IM."),
-	        fields, _("OK"), G_CALLBACK(send_im_select_cb), _("Cancel"),
+	        page, _("OK"), G_CALLBACK(send_im_select_cb), _("Cancel"),
 	        NULL, NULL, NULL);
 }
 
 static void
-join_chat_select_cb(G_GNUC_UNUSED gpointer data, PurpleRequestFields *fields)
-{
+join_chat_select_cb(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
 	PurpleAccount *account;
 	const char *name;
 	PurpleConnection *gc;
@@ -2575,8 +2573,8 @@ join_chat_select_cb(G_GNUC_UNUSED gpoint
 	GHashTable *hash = NULL;
 	PurpleConversation *conv;
 
-	account = purple_request_fields_get_account(fields, "account");
-	name = purple_request_fields_get_string(fields,  "chat");
+	account = purple_request_page_get_account(page, "account");
+	name = purple_request_page_get_string(page, "chat");
 
 	if (!purple_account_is_connected(account))
 		return;
@@ -2610,14 +2608,14 @@ join_chat_select_cb(G_GNUC_UNUSED gpoint
 static void
 join_chat_select(G_GNUC_UNUSED GntMenuItem *item, G_GNUC_UNUSED gpointer n)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("chat", _("Channel"), NULL, FALSE);
 	purple_request_field_set_required(field, TRUE);
@@ -2634,7 +2632,7 @@ join_chat_select(G_GNUC_UNUSED GntMenuIt
 	purple_request_fields(
 	        purple_blist_get_default(), _("Join a Chat"), NULL,
 	        _("Please enter the name of the chat you want to join."),
-	        fields, _("Join"), G_CALLBACK(join_chat_select_cb), _("Cancel"),
+	        page, _("Join"), G_CALLBACK(join_chat_select_cb), _("Cancel"),
 	        NULL, NULL, NULL);
 }
 
diff --git a/finch/gntplugin.c b/finch/gntplugin.c
--- a/finch/gntplugin.c
+++ b/finch/gntplugin.c
@@ -534,13 +534,13 @@ static GntWidget*
 process_pref_frame(PurplePluginPrefFrame *frame)
 {
 	PurpleRequestField *field;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group = NULL;
 	GList *prefs;
 	GList *stringlist = NULL;
 	GntWidget *ret = NULL;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
 	for (prefs = purple_plugin_pref_frame_get_prefs(frame); prefs; prefs = prefs->next) {
 		PurplePluginPref *pref = prefs->data;
@@ -556,7 +556,7 @@ process_pref_frame(PurplePluginPrefFrame
 				purple_request_group_add_field(group, field);
 			} else {
 				group = purple_request_group_new(label);
-				purple_request_fields_add_group(fields, group);
+				purple_request_page_add_group(page, group);
 			}
 			continue;
 		}
@@ -624,13 +624,13 @@ process_pref_frame(PurplePluginPrefFrame
 		if (field) {
 			if (group == NULL) {
 				group = purple_request_group_new(_("Preferences"));
-				purple_request_fields_add_group(fields, group);
+				purple_request_page_add_group(page, group);
 			}
 			purple_request_group_add_field(group, field);
 		}
 	}
 
-	ret = purple_request_fields(NULL, _("Preferences"), NULL, NULL, fields,
+	ret = purple_request_fields(NULL, _("Preferences"), NULL, NULL, page,
 			_("Save"), G_CALLBACK(finch_request_save_in_prefs), _("Cancel"), NULL,
 			NULL, NULL);
 	g_signal_connect_swapped(G_OBJECT(ret), "destroy", G_CALLBACK(free_stringlist), stringlist);
diff --git a/finch/gntprefs.c b/finch/gntprefs.c
--- a/finch/gntprefs.c
+++ b/finch/gntprefs.c
@@ -230,21 +230,19 @@ free_strings(void)
 }
 
 static void
-save_cb(void *data, PurpleRequestFields *allfields)
-{
-	finch_request_save_in_prefs(data, allfields);
+save_cb(void *data, PurpleRequestPage *page) {
+	finch_request_save_in_prefs(data, page);
 	free_strings();
 }
 
 static void
-add_pref_group(PurpleRequestFields *fields, const char *title, Prefs *prefs)
-{
+add_pref_group(PurpleRequestPage *page, const char *title, Prefs *prefs) {
 	PurpleRequestField *field;
 	PurpleRequestGroup *group;
 	int i;
 
 	group = purple_request_group_new(title);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 	for (i = 0; prefs[i].pref; i++)
 	{
 		field = get_pref_field(prefs + i);
@@ -256,22 +254,22 @@ add_pref_group(PurpleRequestFields *fiel
 void
 finch_prefs_show_all(void)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 
 	if (pref_request.showing) {
 		gnt_window_present(pref_request.window);
 		return;
 	}
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
-	add_pref_group(fields, _("Buddy List"), blist);
-	add_pref_group(fields, _("Conversations"), convs);
-	add_pref_group(fields, _("Idle"), idle);
-	add_pref_group(fields, _("Credentials"), credentials);
+	add_pref_group(page, _("Buddy List"), blist);
+	add_pref_group(page, _("Conversations"), convs);
+	add_pref_group(page, _("Idle"), idle);
+	add_pref_group(page, _("Credentials"), credentials);
 
 	pref_request.showing = TRUE;
-	pref_request.window = purple_request_fields(NULL, _("Preferences"), NULL, NULL, fields,
+	pref_request.window = purple_request_fields(NULL, _("Preferences"), NULL, NULL, page,
 			_("Save"), G_CALLBACK(save_cb), _("Cancel"), free_strings,
 			NULL, NULL);
 }
diff --git a/finch/gntrequest.h b/finch/gntrequest.h
--- a/finch/gntrequest.h
+++ b/finch/gntrequest.h
@@ -61,12 +61,12 @@ void finch_request_uninit(void);
 /**
  * finch_request_save_in_prefs:
  * @data: No longer used, set to %NULL.
- * @fields: The #PurpleRequestFields to save.
+ * @page: The #PurpleRequestPage to save.
  *
  * Save the request fields in preferences where the id attribute of each field is the
  * id of a preference.
  */
-void finch_request_save_in_prefs(gpointer data, PurpleRequestFields *fields);
+void finch_request_save_in_prefs(gpointer data, PurpleRequestPage *page);
 
 /**
  * finch_request_field_get_widget:
diff --git a/finch/gntrequest.c b/finch/gntrequest.c
--- a/finch/gntrequest.c
+++ b/finch/gntrequest.c
@@ -167,14 +167,8 @@ finch_request_input(const char *title, c
 }
 
 static void
-finch_close_request(PurpleRequestType type, gpointer ui_handle)
-{
+finch_close_request(G_GNUC_UNUSED PurpleRequestType type, gpointer ui_handle) {
 	GntWidget *widget = GNT_WIDGET(ui_handle);
-	if (type == PURPLE_REQUEST_FIELDS) {
-		PurpleRequestFields *fields = g_object_get_data(G_OBJECT(widget), "fields");
-		purple_request_fields_destroy(fields);
-	}
-
 	widget = gnt_widget_get_toplevel(widget);
 	gnt_widget_destroy(widget);
 }
@@ -278,8 +272,7 @@ finch_request_action(const char *title, 
 }
 
 static void
-request_fields_cb(GntWidget *button, PurpleRequestFields *fields)
-{
+request_fields_cb(GntWidget *button, PurpleRequestPage *page) {
 	PurpleRequestFieldsCb callback = g_object_get_data(G_OBJECT(button), "activate-callback");
 	gpointer data = g_object_get_data(G_OBJECT(button), "activate-userdata");
 	GList *list;
@@ -290,8 +283,7 @@ request_fields_cb(GntWidget *button, Pur
 	 * instantly whenever a change is made. That allows it to make sure the
 	 * 'required' fields are entered before the user can hit OK. It's not the case
 	 * here, although it can be done. */
-	for (list = purple_request_fields_get_groups(fields); list; list = list->next)
-	{
+	for(list = purple_request_page_get_groups(page); list; list = list->next) {
 		PurpleRequestGroup *group = list->data;
 		GList *fields = purple_request_group_get_fields(group);
 
@@ -381,16 +373,17 @@ request_fields_cb(GntWidget *button, Pur
 	purple_notify_close_with_handle(button);
 
 	if (!g_object_get_data(G_OBJECT(button), "cancellation-function") &&
-			(!purple_request_fields_all_required_filled(fields) ||
-			!purple_request_fields_all_valid(fields))) {
+			(!purple_request_page_all_required_filled(page) ||
+			!purple_request_page_all_valid(page))) {
 		purple_notify_error(button, _("Error"),
 			_("You must properly fill all the required fields."),
 			_("The required fields are underlined."), NULL);
 		return;
 	}
 
-	if (callback)
-		callback(data, fields);
+	if(callback) {
+		callback(data, page);
+	}
 
 	window = gnt_widget_get_toplevel(button);
 	purple_request_close(PURPLE_REQUEST_FIELDS, window);
@@ -583,8 +576,7 @@ create_account_field(PurpleRequestField 
 }
 
 static void
-multifield_extra_cb(GntWidget *button, PurpleRequestFields *allfields)
-{
+multifield_extra_cb(GntWidget *button, PurpleRequestPage *page) {
 	PurpleRequestFieldsCb cb;
 	gpointer cb_data;
 	gpointer handle;
@@ -593,8 +585,9 @@ multifield_extra_cb(GntWidget *button, P
 	cb = g_object_get_data(G_OBJECT(button), "extra-cb");
 	cb_data = g_object_get_data(G_OBJECT(button), "extra-cb-data");
 
-	if (cb != NULL)
-		cb(cb_data, allfields);
+	if(cb != NULL) {
+		cb(cb_data, page);
+	}
 
 	action_performed(button, handle);
 	purple_request_close(PURPLE_REQUEST_FIELDS, handle);
@@ -602,7 +595,7 @@ multifield_extra_cb(GntWidget *button, P
 
 static void *
 finch_request_fields(const char *title, const char *primary,
-		const char *secondary, PurpleRequestFields *allfields,
+		const char *secondary, PurpleRequestPage *page,
 		const char *ok, GCallback ok_cb,
 		const char *cancel, GCallback cancel_cb,
 		PurpleRequestCommonParameters *cpar,
@@ -623,7 +616,8 @@ finch_request_fields(const char *title, 
 	box = gnt_vbox_new(FALSE);
 	gnt_box_set_pad(GNT_BOX(box), 0);
 	gnt_box_set_fill(GNT_BOX(box), TRUE);
-	for (grlist = purple_request_fields_get_groups(allfields); grlist; grlist = grlist->next)
+	for(grlist = purple_request_page_get_groups(page); grlist;
+	    grlist = grlist->next)
 	{
 		PurpleRequestGroup *group = grlist->data;
 		GList *fields = purple_request_group_get_fields(group);
@@ -684,8 +678,8 @@ finch_request_fields(const char *title, 
 	}
 	gnt_box_add_widget(GNT_BOX(window), box);
 
-	box = setup_button_box(window, userdata, request_fields_cb, allfields,
-			ok, ok_cb, cancel, cancel_cb, NULL);
+	box = setup_button_box(window, userdata, request_fields_cb, page,
+	                       ok, ok_cb, cancel, cancel_cb, NULL);
 
 	extra_actions = purple_request_cpar_get_extra_actions(cpar);
 	for (GSList *it = extra_actions; it; it = it->next) {
@@ -697,7 +691,7 @@ finch_request_fields(const char *title, 
 		g_object_set_data(G_OBJECT(button), "extra-cb", extra_action->value);
 		g_object_set_data(G_OBJECT(button), "extra-cb-data", userdata);
 		g_signal_connect(G_OBJECT(button), "activate",
-			G_CALLBACK(multifield_extra_cb), allfields);
+		                 G_CALLBACK(multifield_extra_cb), page);
 	}
 
 	help_cb = purple_request_cpar_get_help_cb(cpar, &help_data);
@@ -717,7 +711,7 @@ finch_request_fields(const char *title, 
 		g_signal_connect(username, "completion", G_CALLBACK(update_selected_account), accountlist);
 	}
 
-	g_object_set_data(G_OBJECT(window), "fields", allfields);
+	g_object_set_data_full(G_OBJECT(window), "fields", page, g_object_unref);
 
 	return window;
 }
@@ -857,10 +851,10 @@ finch_request_uninit(void)
 
 void
 finch_request_save_in_prefs(G_GNUC_UNUSED gpointer data,
-                            PurpleRequestFields *allfields)
+                            PurpleRequestPage *page)
 {
 	GList *list;
-	for (list = purple_request_fields_get_groups(allfields); list; list = list->next) {
+	for(list = purple_request_page_get_groups(page); list; list = list->next) {
 		PurpleRequestGroup *group = list->data;
 		GList *fields = purple_request_group_get_fields(group);
 
diff --git a/libpurple/account.c b/libpurple/account.c
--- a/libpurple/account.c
+++ b/libpurple/account.c
@@ -227,13 +227,12 @@ request_password_write_cb(GObject *obj, 
 }
 
 static void
-request_password_ok_cb(PurpleAccount *account, PurpleRequestFields *fields)
-{
+request_password_ok_cb(PurpleAccount *account, PurpleRequestPage *page) {
 	const char *entry;
 	gboolean remember;
 
-	entry = purple_request_fields_get_string(fields, "password");
-	remember = purple_request_fields_get_bool(fields, "remember");
+	entry = purple_request_page_get_string(page, "password");
+	remember = purple_request_page_get_bool(page, "remember");
 
 	if (!entry || !*entry)
 	{
@@ -266,7 +265,7 @@ request_password_ok_cb(PurpleAccount *ac
 
 static void
 request_password_cancel_cb(PurpleAccount *account,
-                           G_GNUC_UNUSED PurpleRequestFields *fields)
+                           G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	/* Disable the account as the user has cancelled connecting */
 	purple_account_set_enabled(account, FALSE);
@@ -315,13 +314,12 @@ purple_account_connect_got_password_cb(G
 }
 
 static void
-change_password_cb(PurpleAccount *account, PurpleRequestFields *fields)
-{
+change_password_cb(PurpleAccount *account, PurpleRequestPage *page) {
 	const char *orig_pass, *new_pass_1, *new_pass_2;
 
-	orig_pass  = purple_request_fields_get_string(fields, "password");
-	new_pass_1 = purple_request_fields_get_string(fields, "new_password_1");
-	new_pass_2 = purple_request_fields_get_string(fields, "new_password_2");
+	orig_pass = purple_request_page_get_string(page, "password");
+	new_pass_1 = purple_request_page_get_string(page, "new_password_1");
+	new_pass_2 = purple_request_page_get_string(page, "new_password_2");
 
 	if (g_utf8_collate(new_pass_1, new_pass_2))
 	{
@@ -332,12 +330,12 @@ change_password_cb(PurpleAccount *accoun
 		return;
 	}
 
-	if ((purple_request_fields_is_field_required(fields, "password") &&
-			(orig_pass == NULL || *orig_pass == '\0')) ||
-		(purple_request_fields_is_field_required(fields, "new_password_1") &&
-			(new_pass_1 == NULL || *new_pass_1 == '\0')) ||
-		(purple_request_fields_is_field_required(fields, "new_password_2") &&
-			(new_pass_2 == NULL || *new_pass_2 == '\0')))
+	if((purple_request_page_is_field_required(page, "password") &&
+	    purple_strempty(orig_pass)) ||
+	   (purple_request_page_is_field_required(page, "new_password_1") &&
+	    purple_strempty(new_pass_1)) ||
+	   (purple_request_page_is_field_required(page, "new_password_2") &&
+	    purple_strempty(new_pass_2)))
 	{
 		purple_notify_error(account, NULL,
 			_("Fill out all fields completely."), NULL,
@@ -1065,7 +1063,7 @@ purple_account_request_password(PurpleAc
 	const gchar *username;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 
 	/* Close any previous password request windows */
 	purple_request_close_with_handle(account);
@@ -1074,9 +1072,9 @@ purple_account_request_password(PurpleAc
 	primary = g_strdup_printf(_("Enter password for %s (%s)"), username,
 								  purple_account_get_protocol_name(account));
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("password", _("Enter Password"), NULL, FALSE);
 	purple_request_field_string_set_masked(field, TRUE);
@@ -1086,7 +1084,7 @@ purple_account_request_password(PurpleAc
 	field = purple_request_field_bool_new("remember", _("Save password"), FALSE);
 	purple_request_group_add_field(group, field);
 
-	purple_request_fields(account, NULL, primary, NULL, fields, _("OK"),
+	purple_request_fields(account, NULL, primary, NULL, page, _("OK"),
 		ok_cb, _("Cancel"), cancel_cb,
 		purple_request_cpar_from_account(account), user_data);
 	g_free(primary);
@@ -1095,7 +1093,7 @@ purple_account_request_password(PurpleAc
 void
 purple_account_request_change_password(PurpleAccount *account)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 	PurpleConnection *gc;
@@ -1109,10 +1107,10 @@ purple_account_request_change_password(P
 	if (gc != NULL)
 		protocol = purple_connection_get_protocol(gc);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("password", _("Original password"),
 										  NULL, FALSE);
@@ -1144,7 +1142,7 @@ purple_account_request_change_password(P
 
 	purple_request_fields(purple_account_get_connection(account), NULL,
 		primary, _("Please enter your current password and your new "
-		"password."), fields, _("OK"), G_CALLBACK(change_password_cb),
+		"password."), page, _("OK"), G_CALLBACK(change_password_cb),
 		_("Cancel"), NULL, purple_request_cpar_from_account(account),
 		account);
 }
diff --git a/libpurple/plugins/idle/idle.c b/libpurple/plugins/idle/idle.c
--- a/libpurple/plugins/idle/idle.c
+++ b/libpurple/plugins/idle/idle.c
@@ -83,11 +83,10 @@ set_idle_time(PurpleAccount *acct, int m
 }
 
 static void
-idle_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestFields *fields)
-{
-	PurpleAccount *acct = purple_request_fields_get_account(fields, "acct");
+idle_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
+	PurpleAccount *acct = purple_request_page_get_account(page, "acct");
 	PurpleContactInfo *info = PURPLE_CONTACT_INFO(acct);
-	int tm = purple_request_fields_get_integer(fields, "mins");
+	int tm = purple_request_page_get_integer(page, "mins");
 
 	/* only add the account to the GList if it's not already been idled */
 	if(!unidle_filter(acct)) {
@@ -100,12 +99,11 @@ idle_action_ok(G_GNUC_UNUSED gpointer da
 }
 
 static void
-idle_all_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestFields *fields)
-{
+idle_all_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
 	PurpleAccountManager *manager = NULL;
 	PurpleAccount *acct = NULL;
 	GList *list, *iter;
-	int tm = purple_request_fields_get_integer(fields, "mins");
+	int tm = purple_request_page_get_integer(page, "mins");
 
 	manager = purple_account_manager_get_default();
 	list = purple_account_manager_get_enabled(manager);
@@ -129,9 +127,8 @@ idle_all_action_ok(G_GNUC_UNUSED gpointe
 }
 
 static void
-unidle_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestFields *fields)
-{
-	PurpleAccount *acct = purple_request_fields_get_account(fields, "acct");
+unidle_action_ok(G_GNUC_UNUSED gpointer data, PurpleRequestPage *page) {
+	PurpleAccount *acct = purple_request_page_get_account(page, "acct");
 
 	set_idle_time(acct, 0); /* unidle the account */
 
@@ -158,7 +155,7 @@ purple_idle_set_account_idle_time(G_GNUC
 {
 	/* Use the super fancy request API */
 
-	PurpleRequestFields *request;
+	PurpleRequestPage *request;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
@@ -172,8 +169,8 @@ purple_idle_set_account_idle_time(G_GNUC
 	field = purple_request_field_int_new("mins", _("Minutes"), 10, 0, 9999);
 	purple_request_group_add_field(group, field);
 
-	request = purple_request_fields_new();
-	purple_request_fields_add_group(request, group);
+	request = purple_request_page_new();
+	purple_request_page_add_group(request, group);
 
 	purple_request_fields(data,
 			N_("I'dle Mak'er"),
@@ -190,7 +187,7 @@ purple_idle_unset_account_idle_time(G_GN
                                     G_GNUC_UNUSED GVariant *parameter,
                                     gpointer data)
 {
-	PurpleRequestFields *request;
+	PurpleRequestPage *request;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
@@ -207,8 +204,8 @@ purple_idle_unset_account_idle_time(G_GN
 	purple_request_field_account_set_show_all(field, FALSE);
 	purple_request_group_add_field(group, field);
 
-	request = purple_request_fields_new();
-	purple_request_fields_add_group(request, group);
+	request = purple_request_page_new();
+	purple_request_page_add_group(request, group);
 
 	purple_request_fields(data,
 			N_("I'dle Mak'er"),
@@ -225,7 +222,7 @@ purple_idle_set_all_accounts_idle_time(G
                                        G_GNUC_UNUSED GVariant *parameter,
                                        gpointer data)
 {
-	PurpleRequestFields *request;
+	PurpleRequestPage *request;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
@@ -234,8 +231,8 @@ purple_idle_set_all_accounts_idle_time(G
 	field = purple_request_field_int_new("mins", _("Minutes"), 10, 0, 9999);
 	purple_request_group_add_field(group, field);
 
-	request = purple_request_fields_new();
-	purple_request_fields_add_group(request, group);
+	request = purple_request_page_new();
+	purple_request_page_add_group(request, group);
 
 	purple_request_fields(data,
 			N_("I'dle Mak'er"),
